<?php
/**
 * CleanTalk SMF mod installation PHP code
 *
 * @package Cleantalk
 * @subpackage SMF
 * @author CleanTalk (welcome@cleantalk.ru)
 * @copyright (C) 2014 Сleantalk team (http://cleantalk.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 */

global $db_connection, $smcFunc;

$hooks = array(
    'integrate_pre_include' => '$sourcedir/cleantalk/CleantalkMod.php',
    'integrate_register' => 'cleantalk_check_register',
    'integrate_general_mod_settings' => 'cleantalk_general_mod_settings',
    'integrate_load_theme' => 'cleantalk_load',
    'integrate_exit' => 'cleantalk_exit',
    'integrate_buffer' => 'cleantalk_buffer',
);

$isInstalling = empty($context['uninstalling']);

// set integration hooks
foreach ($hooks as $hook => $function) {
    if ($isInstalling) {
        add_integration_function($hook, $function);
    } else {
        remove_integration_function($hook, $function);
    }
}

if ($isInstalling) {
    // Anti-Spam Verification captcha disable
    updateSettings(array('reg_verification' => '0'), true);
    updateSettings(array('posts_require_captcha' => '0'), true);

    $oldKey = isset($modSettings['cleantalk_api_key']) ? $modSettings['cleantalk_api_key'] : '';
	
//* OLD
    updateSettings(array('cleantalk_api_key' => $oldKey), false);
    updateSettings(array('cleantalk_first_post_checking' => '1'), false);
    updateSettings(array('cleantalk_logging' => '0'), false);
	
//*/

	
/* NEW
	if($oldKey != ''){
				
		$data = array(
			"method_name" => "notice_validate_key",
			"auth_key" => $oldKey,
		);
		
		$result=null;
		$data=http_build_query($data);
		$data=str_replace("&amp;", "&", $data);
				
		if (function_exists('curl_init') && function_exists('json_decode')){
		
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
			// receive server response ...
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			// resolve 'Expect: 100-continue' issue
			curl_setopt($ch, CURLOPT_HTTPHEADER, array('Expect:'));
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
			
			$result = @curl_exec($ch);
			
			$curl_exec = $result !== false ? true : false;
			
			@curl_close($ch);
		}
		
		if(!$curl_exec){
			$opts = array(
				'http'=>array(
					'method' => "POST",
					'timeout'=> $timeout,
					'content' => $data
				)
			);
			$context = stream_context_create($opts);
			$result = @file_get_contents($url, 0, $context);
		}
				
		$result = ($result != false ? json_decode($result, true): false);
				
		if($result && isset($result['valid']) && $result['valid'] == '1' )
			$cleantalk_api_key_is_ok = '1';
		else
			$cleantalk_api_key_is_ok = '0';
		
		$cleantalk_api_key = $oldKey;
	}else{
		$cleantalk_api_key_is_ok = '0';
		$cleantalk_api_key = '';
	}
	
	updateSettings(array('cleantalk_api_key_is_ok' => $cleantalk_api_key_is_ok), true);
	updateSettings(array('cleantalk_api_key' => '123'), true);
	updateSettings(array('cleantalk_user_token' => '0'), true);
    updateSettings(array('cleantalk_first_post_checking' => '1'), true);
    updateSettings(array('cleantalk_logging' => '0'), true);
	updateSettings(array('cleantalk_js_keys' => '0'), true);
	
///*/
	
    //xdebug_break();
    if (!isset($db_connection) || $db_connection === false) {
	loadDatabase();
    }
    if (!isset($db_connection) || $db_connection === false) {
	trigger_error('CleanTalk install: you need to be connected to the database, please verify connection', E_USER_NOTICE);
    } else {
		db_extend('packages');

		$smcFunc['db_drop_table']('{db_prefix}cleantalk_sfw');

		$columns = array(
			array(
				'name' => 'network',
				'type' => 'int',
				'size' => 11,
				'unsigned' => true,
			),
			array(
				'name' => 'mask',
				'type' => 'int',
				'size' => 11,
				'unsigned' => true,
			),
		);
		$indexes = null;
		$smcFunc['db_create_table']('{db_prefix}cleantalk_sfw', $columns, $indexes, array(), 'update_remove');

		$smcFunc['db_add_column'](
			'{db_prefix}members',
			array(
				'name' => 'ct_marked',
				'type' => 'int',
				'default' => 0
			)
		);
    }
} else {
    // Anti-Spam Verification captcha
    updateSettings(array('reg_verification' => '1'), true);
    //xdebug_break();
	
    if (!isset($db_connection) || $db_connection === false)
		loadDatabase();

    if (!isset($db_connection) || $db_connection === false) {
		trigger_error('CleanTalk uninstall: you need to be connected to the database, please verify connection', E_USER_NOTICE);
    } else {
		db_extend('packages');
		$smcFunc['db_drop_table']('{db_prefix}cleantalk_sfw');
		$smcFunc['db_remove_column']('{db_prefix}members', 'ct_marked', array(), '');
    }
}
